import cgi, time
import b0lib.render
import b0lib.blog
import b0lib.ident

def esc(s):
	return cgi.escape(s, 1)

def RssDate(date):
	#format: Tue, 10 Dec 2002 23:20:46 GMT
	if len(date) == 6:
		date += (0, 0, 0)
	return time.strftime( '%a, %d %b %Y %H:%M:%S GMT', date )

def RenderSinglePost( post ):
	print '<item>'
	print '<title>' + esc( post.GetTitle() ) + '</title>'
	print '<link>' + esc( post.GetUrl() ) + '</link>'
	print '<description>'
	print esc( post.Render() )
	commentUrl = (
		blog.GetCommentsUrl()
		+ '?u=' + blog.GetUsernum()
		+ '&p=' + post.GetId()
		+ '&link=' + esc( post.GetUrl() )
	)
	print esc( '<p><a href="'
		+ esc( commentUrl )
		+ '''" onclick="window.open( this.href, 'comments', 'width=515, height=480, location=0, resizable=1, scrollbars=1, status=0, toolbar=0, directories=0'); return(false);"'''
		+ ''' title="Click here to comment on this post.">Comment</a></p>'''
	)
	print '</description>'
	print '<guid>' + esc( post.GetUrl() ) + '</guid>'
	# write local category info
	for topic, topicurl in post.GetLocalTopics():
		print "<category>%s</category>" % esc(topic)
	# write w4 ENT info
	if post.has_key('wwww'):
		from b0lib import wwww
		print wwww.get_ent_rss(blog, post['wwww'])
	if post.has_key('date'):
		print '<pubDate>' + esc( RssDate(post['date']) ) + '</pubDate>'
	print '<comments>' + esc( commentUrl ) + '</comments>'	
	print "</item>"

def RenderDayOfPosts( day, maxPosts=-1 ):
	"Prints out a calendar day of posts (up to a max number of maxPosts) and returns the number of posts printed"
	nPosts = 0
	post = day.GetLastPost()
	while post:
		RenderSinglePost( post )
		post = post.GetPrevPost()
		if maxPosts != -1 and nPosts >= maxPosts:
			raise b0lib.render.DoneEnoughPosts()
		nPosts += 1
	return (nPosts, '', [])

# Header
emailName = esc( blog.GetObfuscatedEmail() + " (" + blog.GetAuthor() + ")" )
print """<?xml version="1.0"?>
<!-- RSS generated by """ + b0lib.ident.USERAGENT + """ -->
<rss version="2.0" xmlns:ent="http://www.purl.org/NET/ENT/1.0/">
        <channel>
                <title>""" + esc( blog.GetTitle() ) + """</title>
                <link>""" + esc( blog.GetUrl() ) + """</link>
                <description>""" + esc( blog.GetDescription() ) + """</description>
                <copyright>Copyright """ + str(blog.GetThisYearNumber()) + ' ' + esc( blog.GetAuthor() ) + """</copyright>
                <lastBuildDate>""" + time.strftime( '%a, %d %b %Y %H:%M:%S GMT', time.gmtime() ) + """</lastBuildDate>
                <docs>http://backend.userland.com/rss2</docs>
                <managingEditor>""" + emailName + """</managingEditor>
                <webMaster>""" + emailName + """</webMaster>
		<generator>bzero; http://www.myelin.co.nz/bzero/</generator>
"""

# Posts
b0lib.render.RenderPostList( blog, 10, RenderDayOfPosts )

# Footer
print """
	</channel>
</rss>

"""

